SystemOrganization addCategory: #'Mixins-Example'!
SystemOrganization addCategory: #Mixins!
SystemOrganization addCategory: #'Mixins-IntermediateClasses'!
SystemOrganization addCategory: #'Mixins-Example-MixinIntClasses'!

ClassBuilder subclass: #MixinIntermediateClassBuilder
	instanceVariableNames: ''
	classVariableNames: 'Counter'
	poolDictionaries: ''
	category: 'Mixins'!

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:20'!
addMethodsToClass: class fromMixin: mixinClass
	"Add all (direct) methods of mixinClass to class.
	class and mixinClass may eighter be classes or metaclasses."

	mixinClass selectorsDo: [:selector | 
		class compileSilently: (mixinClass sourceCodeAt: selector) classified: nil
	].
	^ class.! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:20'!
createClassFromSuperclass: superClass mixin: mixinClass
	"Return a subclass of superClass, where all (direct) class/instance variables of mixinClass are added."

	| newClass newClassName classVariablesString instanceVariablesString classInstanceVariablesString |
	newClassName := self mixinSubclassNameForSuperclass: superClass mixin: mixinClass.
	classVariablesString := self variablesStringForMixin: mixinClass into: superClass classSide: true.
	instanceVariablesString := self variablesStringForMixin: mixinClass into: superClass classSide: false.
	classInstanceVariablesString := self variablesStringForMixin: mixinClass class into: superClass class classSide: false.
	newClass := self
		name: newClassName
		inEnvironment: superClass environment
		subclassOf: superClass
		type: superClass typeOfClass
		instanceVariableNames: instanceVariablesString
		classVariableNames: classVariablesString
		poolDictionaries: mixinClass sharedPoolsString
		category: MixinManager uniqueInstance intermediateClassesCategory.
	newClass mixinSuperclass: mixinClass.
	newClass class instanceVariableNames: classInstanceVariablesString.
	newClass classComment: 'AUTOMATICALLY GENERATED CLASS. DO NOT EDIT!! DO NOT MOVE TO ANOTHER CATEGORY!!
This class was generated from class "', superClass name, '" by mixing in class "', mixinClass name, '".'.
	^ newClass.! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:20'!
getUniqueNumber

	Counter ifNil: [^ Counter _ 0].
	Counter := Counter + 1.
	^ Counter! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 16:39'!
mixinSubclassNameForSuperclass: superClass mixin: mixinClass
	"Generate and return a unique name for the new class (as symbol)."

	| env namePrefix name |
	env := superClass environment.
	"namePrefix := superClass name, mixinClass name."
	namePrefix := 'MIntermediate'.
	[name := (namePrefix, self getUniqueNumber asString) asSymbol] doWhileTrue: [
		env includesKey: name
	].
	^ name.! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:21'!
newSuperMetaFor: newSuper
	^ (newSuper == Object) 
		ifTrue: [MixinIntermediateClass] 
		ifFalse: [newSuper class]! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:20'!
privateNewSubclassOf: newSuper
	"Create a new meta and non-meta subclass of newSuper"
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newSuperMeta newMeta |
	newSuperMeta := self newSuperMetaFor: newSuper.
	newMeta := MixinIntermediateMetaclass new.
	newMeta 
		superclass: newSuperMeta 
		methodDictionary: MethodDictionary new 
		format: newSuperMeta format.
	^newMeta new
! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:20'!
privateNewSubclassOf: newSuper from: oldClass
	"Create a new meta and non-meta subclass of newSuper using oldClass as template"
	"WARNING: This method does not preserve the superclass/subclass invariant!!"
	| newSuperMeta oldMeta newMeta |
	oldClass ifNil:[^self privateNewSubclassOf: newSuper].
	newSuperMeta := self newSuperMetaFor: newSuper.
	oldMeta := oldClass class.
	newMeta := oldMeta clone.
	newMeta 
		superclass: newSuperMeta
		methodDictionary: MethodDictionary new
		format: (self computeFormat: oldMeta typeOfClass 
					instSize: oldMeta instVarNames size 
					forSuper: newSuperMeta
					ccIndex: 0);
		setInstVarNames: oldMeta instVarNames;
		organization: oldMeta organization.
	"Recompile the meta class"
	oldMeta hasMethods 
		ifTrue:[newMeta compileAllFrom: oldMeta].
	"Record the meta class change"
	self recordClass: oldMeta replacedBy: newMeta.
	"And create a new instance"
	^newMeta adoptInstance: oldClass from: oldMeta! !

!MixinIntermediateClassBuilder methodsFor: 'public' stamp: 'bs 2/21/2010 13:20'!
superclass: superClass mixin: mixinClass
	"Define a new class as subclass of superClass and apply the mixinClass to it, i.e. add all (direct) class/instance variables, pool dictionaries, class instance variables and class/instance methods to it.
	Implementation of the <+ operator."

	| newClass |
	(superClass == mixinClass)
	ifTrue: [
		self error: 'Mixing class ', mixinClass name, ' into itself!!'.
		^ superClass
	].
	(mixinClass isIntermediateClass)
	ifTrue: [
		self error: mixinClass name, ': Don''t use intermediate classes as mixins!!'.
		^ superClass
	].
	(superClass inheritsFrom: mixinClass)
	ifTrue: [
		self error: 'Class ', mixinClass name, ' can''t be mixed into class ', superClass name, '; ',  superClass name, ' is a subclass of ', mixinClass name, '!!'.
		^ superClass
	].
	newClass := self createClassFromSuperclass: superClass mixin: mixinClass.
	self addMethodsToClass: newClass class fromMixin: mixinClass class. "class methods"
	self addMethodsToClass: newClass fromMixin: mixinClass. "instance methods"
	^ newClass.! !

!MixinIntermediateClassBuilder methodsFor: 'private' stamp: 'bs 2/21/2010 13:21'!
variablesStringForMixin: mixinClass into: superClass classSide: classSide
	"Return a string of variable names, which have to be added to superClass in order to mixin mixinClass. If classSide = true; consider class vars, inst vars otherwise.
	Check and warn, if not all variables of mixinClass can be added."
	
	| mixinVars superClassVars existingVars nonExistingVars |
	mixinVars := (classSide) ifTrue: [mixinClass classVarNames] ifFalse: [mixinClass instVarNames].
	superClassVars := (classSide) ifTrue: [superClass allClassVarNames] ifFalse: [superClass allInstVarNames].
	nonExistingVars := mixinVars difference: superClassVars.
	existingVars := mixinVars difference: nonExistingVars.
	existingVars do: [:each | MixinDoubleVariableWarning signalVarName: each mixinSuperclass: superClass mixinClass: mixinClass].
	^ String streamContents: [:stream | nonExistingVars asStringOn: stream delimiter: ' ']! !

Object subclass: #MFoo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins-Example'!

!MFoo methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 13:29'!
foo
	^ 'foo'! !

Object subclass: #MIntermediate8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins-Example-MixinIntClasses'!

!MIntermediate8 commentStamp: '<historical>' prior: 0!
AUTOMATICALLY GENERATED CLASS. DO NOT EDIT!! DO NOT MOVE TO ANOTHER CATEGORY!!
This class was generated from class "Object" by mixing in class "MFoo".!

MIntermediate8 subclass: #MBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins-Example'!

!MBar methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 13:29'!
bar
	^ self foo, 'Bar'.! !

!MIntermediate8 methodsFor: 'as yet unclassified' stamp: ''!
foo
	^ 'foo'! !

Object subclass: #MixinManager
	instanceVariableNames: ''
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'Mixins'!

!MixinManager commentStamp: 'MR 12/18/2009 18:23' prior: 0!
Singleton implementing functionality concerning mixin inheritance.!

!MixinManager class methodsFor: 'error handling' stamp: 'MR 12/18/2009 18:52'!
doesNotUnderstand: aMessage 

	"if the instance can handle the request, pass it there"
	(self canUnderstand: aMessage selector) ifTrue: [
		^ self uniqueInstance perform: aMessage selector withArguments: aMessage arguments.].
	
	^ super doesNotUnderstand: aMessage.! !

!MixinManager class methodsFor: 'instance creation' stamp: 'MR 12/18/2009 18:40'!
new

	^ self error: 'Singleton, use uniqueInstance.'! !

!MixinManager class methodsFor: 'accessing' stamp: 'MR 12/21/2009 14:44'!
uniqueInstance

	^ UniqueInstance ifNil: [
		UniqueInstance := self basicNew initialize.
		UniqueInstance registerForSystemChangeNotifications;
						yourself.
	].! !

!MixinManager methodsFor: 'as yet unclassified' stamp: 'MR 2/4/2010 17:19'!
about

^ '
SwaMixins - Extending Squeak with Mixins
==================================================

What is a mixin?
A mixin is a reusable entity of code. It can be applied to classes and then extends the functionality of the class by those defined in the mixin. 
Here, we simply treat all classes as mixins. This means, that you can reuse all the code in the Squeak image in a fashion similar to multiple inheritance. Nice, isn''t it?
When using a class as mixin, the mixin contains everything, which is directly defined in the class, i.e. class methods, class instance variables, class variables, instance methods, instance variables, pool dictionaries. Everything inherited from superclasses is discarded. 

How to use it?
You use the ordinary subclass message, but instead of specifying one single superclass, you can add multiple classes, which extend the functionality of the superclass. 
Example:
YourSuperclass <+ AClassToMixin <+ AnotherClassToMixin subclass: #YourComposedSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''YourCategory''

So #<+ is the mixin application operator. The order, in which you specify the mixin classes determines, how references to superclasses in methods (via super) are resolved. 

If you need to extend a class by another class, whose functionality is provided by multiple classes in one hierarchy (e.g. Array), you can use the following shortcut:
YourSuperclass <+ (Collection -> Array) subclass: #YourComposedSubclassWithArray
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''YourCategory''

The above is exactly the same as:
YourSuperclass <+ Collection <+ SequenceableCollection <+ ArrayedCollection <+ Array subclass: #YourComposedSubclassWithArray
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''YourCategory''


More information and latest version on SqueakSource: http://www.squeaksource.com/SwaMixins.html

Licensed under the MIT-license:
 
 Copyright (c) 2009 Matthias Richly, David Jger, Edgar Nther

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
'! !

!MixinManager methodsFor: 'accessing' stamp: 'MR 12/19/2009 11:35'!
allIntermediateClasses
	"Return a collection of all intermediate classes in the system."
	
	^ (SystemOrganization listAtCategoryNamed: self intermediateClassesCategory) collect: [:classSymbol | Smalltalk at: classSymbol]! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'MR 12/30/2009 16:52'!
deregisterFromSystemChangeNotifications
	"deregister all handler methods"
	
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.
	^ self! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'bs 2/21/2010 13:22'!
handleClassModifiedEvent: anEvent

	anEvent item isIntermediateClass ifTrue: [^ nil]. "nothing to do"
	
	(anEvent areClassVarsModified or: [anEvent areInstVarsModified] or: [anEvent areSharedPoolsModified])
	ifTrue: [
	| addedClassVars removedClassVars addedInstVars removedInstVars |
	
	(anEvent areClassVarsModified)
	ifFalse: [addedClassVars := removedClassVars := #()]
	ifTrue: [
		addedClassVars := anEvent classVarNames difference: anEvent oldClassVarNames.
		removedClassVars := anEvent oldClassVarNames difference: anEvent classVarNames.
	].
	(anEvent areInstVarsModified)
	ifFalse: [addedInstVars := removedInstVars := #()]
	ifTrue: [
		addedInstVars := anEvent instVarNames difference: anEvent oldInstVarNames.
		removedInstVars := anEvent oldInstVarNames difference: anEvent instVarNames.
	].
	
	"Update class/instance variables of all dependent intermediate classes (classes, which have the modified class as mixin superclass)."
	anEvent item mixinSubclasses ifNotEmptyDo: [:mixinSubclasses |
		mixinSubclasses do: [:class | 
			| newClassVariables newClassVariablesString newInstanceVariables newInstanceVariablesString |
			newClassVariables := class classVarNames asSet difference: removedClassVars.
			addedClassVars do: [:var | 
				(class allClassVarNames includes: var)
				ifTrue: [MixinDoubleVariableWarning signalVarName: var mixinSuperclass: class superclass mixinClass: anEvent item intermediateClass: class]
				ifFalse: [newClassVariables add: var]
			].
			newClassVariablesString := String streamContents: [:stream | newClassVariables asStringOn: stream delimiter: ' '].
			
			newInstanceVariables := class instVarNames asSet difference: removedInstVars.
			addedInstVars do: [:var | 
				(class allInstVarNames includes: var)
				ifTrue: [MixinDoubleVariableWarning signalVarName: var mixinSuperclass: class superclass mixinClass: anEvent item intermediateClass: class]
				ifFalse: [newInstanceVariables add: var]
			].
			newInstanceVariablesString := String streamContents: [:stream | newInstanceVariables asStringOn: stream delimiter: ' '].
			
			(anEvent item isMeta)
			ifTrue: [
				(MixinIntermediateClassBuilder new)
					class: class
					instanceVariableNames: newInstanceVariablesString
			]
			ifFalse: [
				(MixinIntermediateClassBuilder new)
					name: class name
					inEnvironment: class environment
					subclassOf: class superclass
					type: class typeOfClass
					instanceVariableNames: newInstanceVariablesString
					classVariableNames: newClassVariablesString
					poolDictionaries: anEvent item sharedPoolsString "in case, it was modified, too"
					category: class category
			]
		].
	].

	"Update intermediate subclasses of the modified class; i.e. if variables have been removed and if variables with the same name are required by (and also defined in) mixins, add the variables to the intermediate class."
	(removedClassVars isEmpty and: [removedInstVars isEmpty]) ifFalse: [
		anEvent item allSubclassesDo: [:class | 
			class isIntermediateClass ifTrue: [ | missingClassVars missingInstVars newClassVariablesString newInstanceVariablesString |
				missingClassVars := removedClassVars intersection: class mixinSuperclass classVarNames.
				newClassVariablesString := String streamContents: [:stream | (class classVarNames asSet addAll: missingClassVars; yourself) asStringOn: stream delimiter: ' '].
				
				missingInstVars := removedInstVars intersection: class mixinSuperclass instVarNames.
				newInstanceVariablesString := String streamContents: [:stream | (class instVarNames asSet addAll: missingInstVars; yourself) asStringOn: stream delimiter: ' '].
				
				(MixinIntermediateClassBuilder new)
					name: class name
					inEnvironment: class environment
					subclassOf: class superclass
					type: class typeOfClass
					instanceVariableNames: newInstanceVariablesString
					classVariableNames: newClassVariablesString
					poolDictionaries: class sharedPoolsString
					category: class category
			]
		]
	]].

	"If the superclass changed and the old superclass was an intermediate class, the intermediate class (and its intermediate superclasses) become unused, so remove them."
	(anEvent isSuperclassModified and: [anEvent oldSuperclass isIntermediateClass])
	ifTrue: [
		self removeIntermediateSuperclassesFor: anEvent oldItem
	].! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'MR 1/11/2010 23:01'!
handleClassRemovedEvent: anEvent

	anEvent item isMeta ifTrue: [^ nil]. "don't handle metaclass changes"
	self removeIntermediateSuperclassesFor: anEvent item.
	
	"Remove classes, which used the deleted class as mixin."
	"Is this really what we should do here? Asking the user could be an option, but we can't be sure, that there is a user sitting in front. Doing just nothing may also be appropriate. But a System Browser may ask and optionally delete."
	"self removeMixinSubclassesForClass: anEvent item silent: true." "delete without asking"
	self removeMixinSubclassesForClass: anEvent item silent: false. "ask and optionally delete"! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'MR 1/22/2010 11:09'!
handleMethodAddedEvent: anEvent

	| source |
	source :=  anEvent itemClass sourceCodeAt: anEvent itemSelector.
	anEvent itemClass mixinSubclasses do: [:each |
		each compileSilently: source classified: nil
	]! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'MR 1/22/2010 10:59'!
handleMethodModifiedEvent: anEvent

	self handleMethodAddedEvent: anEvent! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'MR 1/22/2010 10:58'!
handleMethodRemovedEvent: anEvent

	anEvent itemClass mixinSubclasses do: [:each | 
		each removeSelectorSilently: anEvent itemSelector
	]! !

!MixinManager methodsFor: 'accessing' stamp: 'bs 2/21/2010 16:36'!
intermediateClassesCategory
	"Return a category name, where all the intermediate classes are created in."

	^ 'Mixins-IntermediateClasses'! !

!MixinManager methodsFor: 'system-change event handling' stamp: 'MR 12/30/2009 16:52'!
registerForSystemChangeNotifications
	"register all handler methods at the system's change notifier"
	
	| notifier |
	notifier := SystemChangeNotifier uniqueInstance.
	notifier noMoreNotificationsFor: self.
	
	"class changes"
	notifier notify: self ofSystemChangesOfItem: #class change: #Modified using: #handleClassModifiedEvent:.
	notifier notify: self ofSystemChangesOfItem: #class change: #Removed using: #handleClassRemovedEvent:.
	
	"method changes"
	notifier notify: self ofSystemChangesOfItem: #method change: #Added using: #handleMethodAddedEvent:.
	notifier notify: self ofSystemChangesOfItem: #method change: #Modified using: #handleMethodModifiedEvent:.
	notifier notify: self ofSystemChangesOfItem: #method change: #Removed using: #handleMethodRemovedEvent:.
	
	^ self! !

!MixinManager methodsFor: 'cleanup' stamp: 'MR 1/11/2010 22:19'!
removeAllIntermediateClasses
	"Remove all classes generated for mixin inheritance. Use carefully!!"

	self allIntermediateClasses do: [:class | class removeFromSystem: false].
	^ self.! !

!MixinManager methodsFor: 'cleanup' stamp: 'MR 12/21/2009 17:40'!
removeAllUnusedIntermediateClasses
	"Remove all intermediate classes, which have no non-intermediate subclass."

	| intermediatesWoSubclasses classes |
	intermediatesWoSubclasses _ (self allIntermediateClasses select: [:each | each subclasses isEmpty]).
	classes _ IdentitySet newFrom: intermediatesWoSubclasses.
	intermediatesWoSubclasses do: [:class | classes addAll: class intermediateSuperclasses].
	classes do: [:class | class removeFromSystem: false].
	^ self.! !

!MixinManager methodsFor: 'cleanup' stamp: 'MR 12/21/2009 17:03'!
removeIntermediateSuperclassesFor: aClass
	"Remove all direct intermediate superclasses of aClass."

	aClass intermediateSuperclasses do: [:each | each removeFromSystem: false].
	^ self.! !

!MixinManager methodsFor: 'cleanup' stamp: 'MR 1/11/2010 22:57'!
removeMixinSubclassesForClass: aClass silent: silent
	"Remove all classes (and dependent intermediate classes), which used the given class as mixin. If silent = false, ask the user for acknowledgement."

	| mixinSubclasses |
	mixinSubclasses := aClass mixinSubclasses.
	mixinSubclasses ifNotEmpty: [ | answer |
		(silent)
		ifTrue: [answer := true]
		ifFalse: [answer := self confirm: 'The class ', aClass name, ' has been used as mixin.\Do you want to delete all generated intermediate classes and all of their subclasses?' withCRs.].
		answer ifTrue: [ | classes |
			classes := IdentitySet new.
			mixinSubclasses do: [:each | classes addAll: each allSubclasses].
			(silent) ifFalse: [ | confirm |
				confirm := WriteStream on: (String new: 1000).
				confirm nextPutAll: 'The following class(es) will be removed from the system:'.
				confirm cr.
				classes do: [:each | confirm nextPutAll: each name. confirm cr.].
				confirm nextPutAll: 'Continue?'.
				answer := self confirm: confirm contents.
			].
			answer ifTrue: [
				classes do: [:each | each removeFromSystem: false].
			].
		].
	].! !

!MixinManager methodsFor: 'as yet unclassified' stamp: 'MR 2/4/2010 15:53'!
showAbout

	^ StringHolder new
		acceptContents: self about;
		openLabel: 'SwaMixins - About'.! !

!Metaclass methodsFor: '*Mixins-accessing' stamp: 'MR 1/17/2010 14:30'!
actualSuperclass
	"Orthogonal to Class>>actualSuperclass"
	
	^ self theNonMetaClass actualSuperclass theMetaClass! !

!Metaclass methodsFor: '*Mixins-accessing' stamp: 'bs 2/21/2010 13:04'!
isIntermediateClass
	^ false! !

!Metaclass methodsFor: '*Mixins-printing' stamp: 'bs 2/21/2010 13:05'!
mixinComposition

	^ self theNonMetaClass mixinComposition! !

!Metaclass methodsFor: '*Mixins-accessing' stamp: 'MR 12/27/2009 15:07'!
mixinSubclasses
	"Orthogonal to Class>>mixinSubclasses return a collection of intermediate classes metaclasses, which have the non-meta-class of this class as mixin superclass."

	^ self theNonMetaClass mixinSubclasses collect: [:each | each theMetaClass]! !

!Metaclass methodsFor: '*Mixins-accessing' stamp: 'MR 1/17/2010 14:31'!
mixinSuperclasses
	"Orthogonal to Class>>mixinSuperclasses"

	^ self theNonMetaClass mixinSuperclasses collect: [:each | each theMetaClass]! !

!Metaclass methodsFor: '*Mixins-printing' stamp: 'MR 1/17/2010 14:33'!
printMixinCompositionOn: aStream

	^ self theNonMetaClass printMixinCompositionOn: aStream! !

Metaclass subclass: #MixinIntermediateMetaclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins'!

!MixinIntermediateMetaclass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:20'!
actualSubclass
	"Orthogonal to Class>>actualSubclass"
	
	^ self theNonMetaClass actualSubclass theMetaClass! !

!MixinIntermediateMetaclass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:20'!
isIntermediateClass
	^ true! !

TestCase subclass: #MFooBarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins-Example'!

!MFooBarTest methodsFor: 'as yet unclassified' stamp: 'bs 2/21/2010 15:43'!
testFooBarComposition
	self should: [MBar new bar = 'fooBar' ]! !

Warning subclass: #MixinDoubleVariableWarning
	instanceVariableNames: 'varName mixinSuperclass mixinClass intermediateClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins'!

!MixinDoubleVariableWarning class methodsFor: 'exceptionInstantiator' stamp: 'bs 2/21/2010 13:21'!
signalVarName: varName mixinSuperclass: superClass mixinClass: mixinClass

	^ self signalVarName: varName mixinSuperclass: superClass mixinClass: mixinClass intermediateClass: nil.! !

!MixinDoubleVariableWarning class methodsFor: 'exceptionInstantiator' stamp: 'bs 2/21/2010 13:21'!
signalVarName: varName mixinSuperclass: superClass mixinClass: mixinClass intermediateClass: intermediateClass

	^ self new
		varName: varName;
		mixinSuperclass: superClass;
		mixinClass: mixinClass;
		intermediateClass: intermediateClass;
		signal.! !

!MixinDoubleVariableWarning methodsFor: 'exceptionDescription' stamp: 'bs 2/21/2010 13:21'!
defaultAction

	| stream message |
	stream := WriteStream on: (String new: 400).
	(self intermediateClass)
	ifNil: [stream nextPutAll: 'A new IntermediateClass (class)']
	ifNotNilDo: [:ic | | cl |
		cl := ic actualSubclass.
		stream nextPutAll: cl name.
		stream nextPutAll: ' (= '.
		cl printMixinCompositionOn: stream.
		stream nextPutAll: ')'.
	].
	stream nextPutAll: ': Variable '''.
	stream nextPutAll: self varName.
	stream nextPutAll: ''' does already exist in class '.
	stream nextPutAll: self mixinSuperclass name.
	stream nextPutAll: ' and can''t be added from mixin class '.
	stream nextPutAll: self mixinClass name.
	stream nextPutAll: '. The existing variable will be reused by the mixin''s code (with probably unexpected results).'.
	
	message := stream contents.
	self inform: (message withNoLineLongerThan: 80).
	Transcript ensureEndsWith: Character cr; show: message; cr.
	self resume.! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
intermediateClass
	"The intermediate class, which was build for the mixin application (if already build)."

	^ intermediateClass! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
intermediateClass: anObject

	intermediateClass := anObject! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
mixinClass
	"The class, which was used as mixin."

	^ mixinClass! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
mixinClass: anObject

	mixinClass := anObject! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
mixinSuperclass
	"The class, where the mixin should be applyied to."

	^ mixinSuperclass! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
mixinSuperclass: anObject

	mixinSuperclass := anObject! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
varName
	"The name of the class/instance variable, which caused the warning."

	^ varName! !

!MixinDoubleVariableWarning methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
varName: anObject

	varName := anObject! !

!Class methodsFor: '*Mixins' stamp: 'bs 2/21/2010 13:20'!
<+ param
	"Mixin application operator. Can be used in two different ways:
	- If param is a class, apply param to self. Result is an intermediate class, a subclass of self, where all class/instance variables/methods of param are added.
	- If param is an association Class1->Class2 and Class2 inherits from Class1, a shortcut for self <+ Class1 <+ ... <+ Class2.
	Example: write 'aClass <+ (Collection->Array)' instead of 'aClass <+ Collection <+ SequenceableCollection <+ ArrayedCollection <+ Array'"
	
	(param isKindOf: Class)
	ifTrue: [
		(param isIntermediateClass)
		ifTrue: [^ (MixinIntermediateClassBuilder new) superclass: self mixin: param mixinSuperclass]
		ifFalse: [^ (MixinIntermediateClassBuilder new) superclass: self mixin: param]
	]
	ifFalse: [ "param is an association -> break it down recursivly"
		(param key == param value) "end condition"
		ifTrue: [^ self <+ param value]
		ifFalse: [
			(param value inheritsFrom: param key)
			ifFalse: [self error: param value name, ' is no subclass of ', param key name]
			ifTrue: [^ self <+ (param key -> param value superclass) <+ param value]
		]
	]! !

!Class methodsFor: '*Mixins-accessing' stamp: 'MR 1/5/2010 21:42'!
actualSuperclass
	"Answer the first superclass up the inheritance chain, which is no intermediate class."
	
	| sClass |
	sClass := self superclass.
	[sClass isIntermediateClass] whileTrue: [sClass := sClass superclass].
	^ sClass! !

!Class methodsFor: '*Mixins-accessing' stamp: 'MR 12/21/2009 16:58'!
intermediateSuperclasses
	"Return intermediate classes, which are direct superclasses of this class, i.e. stop searching, when a superclass is no intermediate class. The order in the collection is bottom-up, i.e. the direct superclass appears first."

	| collection sClass |
	collection := OrderedCollection new.
	sClass := self superclass.
	[sClass isIntermediateClass] whileTrue: [
		collection add: sClass.
		sClass := sClass superclass.].
	^ collection! !

!Class methodsFor: '*Mixins-accessing' stamp: 'bs 2/21/2010 13:07'!
isIntermediateClass
	"answer whether this class is an intermediate class generated for mixin inheritance"
	
	^ false! !

!Class methodsFor: '*Mixins-printing' stamp: 'MR 12/30/2009 18:41'!
mixinComposition
	"Return a string containing:
		- the actual superclass of this class
		- the mixins used in this class"
	
	^ String streamContents: [:stream | self printMixinCompositionOn: stream]! !

!Class methodsFor: '*Mixins-accessing' stamp: 'MR 12/21/2009 14:24'!
mixinSubclasses
	"Return a collection of intermediate classes, which have this class as mixin superclass, i,e, which were created by mixing in this class."

	^ MixinManager uniqueInstance allIntermediateClasses select: [:each | each mixinSuperclass = self]! !

!Class methodsFor: '*Mixins-accessing' stamp: 'MR 1/5/2010 21:45'!
mixinSuperclasses
	"Return the mixin superclasses of all intermediate classes, which are direct superclasses of this class, i.e. stop searching, when a superclass is no intermediate class. The order in the collection is top->down, i.e. the class, which was mixed in first, appears first."

	| collection sClass |
	collection := OrderedCollection new.
	sClass := self superclass.
	[sClass isIntermediateClass] whileTrue: [
		collection add: sClass mixinSuperclass.
		sClass := sClass superclass.].
	^ collection reversed! !

!Class methodsFor: '*Mixins-printing' stamp: 'MR 12/30/2009 18:39'!
printMixinCompositionOn: aStream
	"Print on aStream:
		- the actual superclass of this class
		- the mixins used in this class"
	
	aStream nextPutAll: self actualSuperclass name.
	self mixinSuperclasses do: [:each |
		aStream nextPutAll: ' <+ '.
		aStream nextPutAll: each name.
	].! !

Class subclass: #MixinIntermediateClass
	instanceVariableNames: 'mixinSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mixins'!

!MixinIntermediateClass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
actualSubclass
	"For intermediate classes, answer the first non-intermediate class down the inheritance chain. Self otherwise."
	
	| class |
	self isIntermediateClass ifFalse: [^ self].
	[
		class := self subclasses anyOne.
		[class isIntermediateClass] whileTrue: [class := class subclasses anyOne].
		^ class
	] on: Error do: [^ self]! !

!MixinIntermediateClass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
definition
	"Answer a String that defines the receiver. Consider mixin inheritance here."
	
	| superResult |
	superResult := super definition.
	"change the superclass string, if this class has mixin superclasses"
	self mixinSuperclasses ifNotEmptyDo: [:mixins | | pos superClassName stream |
		superClassName := self superclass name.
		pos := superResult findString: superClassName.
		(pos ~= 0) 
		ifTrue: [
			stream := WriteStream on: (String new: 500).
			stream nextPutAll: (superResult copyFrom: 1 to: pos-1).
			self printMixinCompositionOn: stream.
			stream nextPutAll: (superResult copyFrom: pos + superClassName size to: superResult size).
			^ stream contents
		].
	].
	^ superResult! !

!MixinIntermediateClass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
isIntermediateClass
	"answer whether this class is an intermediate class generated for mixin inheritance"
	
	^ true! !

!MixinIntermediateClass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
mixinSuperclass
	"Return the class, which was used to build this intermediate class by mixin inheritance.
The overall assumption is, that this value is unequal nil only for intermediate classes and nil for all other classes."

	^ mixinSuperclass! !

!MixinIntermediateClass methodsFor: 'accessing' stamp: 'bs 2/21/2010 13:21'!
mixinSuperclass: aClass
	"Set the class, which was used to build this intermediate class by mixin inheritance.
The overall assumption is, that this value is unequal nil only for intermediate classes and nil for all other classes. The value is set, when the intermediate class is build. Do not change it afterwards!!"

	mixinSuperclass := aClass.! !

!MixinIntermediateClass methodsFor: 'subclass creation' stamp: 'bs 2/21/2010 15:42'!
subclass: classSymbol instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat
	| aClass mixinIntCategory |
	aClass := super subclass: classSymbol instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat.
	
	mixinIntCategory := cat, '-MixinIntClasses'.
	aClass intermediateSuperclasses do: [ :ea | 
		ea category: mixinIntCategory ].
	^ aClass.! !
